from machine import Pin
import time
import ppCMDR as CMD

RELAY2baseADDR=0x48
MAXADDR=8
relaysPresent = list(range(8))

#==============================================================================#
# HELP Functions                                                               #
#==============================================================================#
helpPath="lib/helpFiles/RELAY2help.txt"

def Help():
    help()

def HELP():
    help()
    
def help():
    valid=True
    try:    
        f=open(helpPath,'r')
        while(valid):
            Count=0
            while (Count<20):
                s=f.readline()
                if (len(s)!=0):
                    print (s[:len(s)-1])
                    Count = Count + 1
                    if (Count==20):
                        input('press \"Enter\" for more...')
                else:
                    Count=100
                    valid=False
        f.close()
    except:
        print ("No help file found.")

#==============================================================================#
# RELAY Functions	                                                           #
#==============================================================================#
def relayON(addr,relay):
    VerifyADDR(addr)
    VerifyRELAY(relay)
    ppCMDr(addr,0x10,relay-1,0,0)

def relayOFF(addr,relay):
    VerifyADDR(addr)
    VerifyRELAY(relay)
    ppCMDr(addr,0x11,relay-1,0,0)
    
def relayTOGGLE(addr,relay):
    VerifyADDR(addr)
    VerifyRELAY(relay)
    ppCMDr(addr,0x12,relay-1,0,0) 

#==============================================================================#
# I/O and Low Level Functions                                                  #
#==============================================================================#
def VerifyADDR(addr):
    assert ((addr>=0) and (addr<MAXADDR)),"RELAYplate address out of range"
    addr_str=str(addr)
    assert (relaysPresent[addr]==1),"No RELAYplate found at address "+addr_str       
    
def VerifyRELAY(relay):
    assert ((relay>=1) and (relay<=8)),"Relay number out of range. Must be between 1 and 8"

def getADDR(addr):
    global RELAY2baseADDR
    resp = []
    resp=ppCMDr(addr,0x00,0,0,1)
    return resp[0]-RELAY2baseADDR

def quietPoll():   
    global relaysPresent
    ppFoundCount=0
    for i in range (0,8):
        relaysPresent[i]=0
        rtn=getADDR(i)
        if (rtn==i):           
            relaysPresent[i]=1
            ppFoundCount += 1

def ppCMDr(addr,cmd,param1,param2,bytes2return):
    global RELAY2baseADDR
    return CMD.ppCMDer(addr+RELAY2baseADDR,cmd,param1,param2,bytes2return)


quietPoll()
